
<?php
	include("common.php");
	
	$input = ArgvToInput();
	$root = GetDocumentRoot();
	
	$options = $input['options']; 
	$file = $input['file'];
	
	// launch ruby
	$handle = popen("usr/bin/ruby $options \"$file\" 2>&1", "r"); //
	$buffer = fread($handle, 1024 * 32);
	// ack! read in a loop until we get eof!! this sometimes returns partial results
	
	/*
		message|line|file
		file|line|function
	*/
	if ($buffer != "") {
		$lines = explode("\n", $buffer);
		foreach ($lines as $value) {
			
			//print("$value\n");
			
			// parse stack trace
			if (eregi("^[\t]+from (.*):([1-9]+):in `(.*)'$", $value, $results)) {
				$file = GetPathLastComponent($results[1]);
				$frame = "$file|$results[2]|$results[3]|";
				$stack_frames .= "$frame\n";
			}
			
			// syntax error
			if (eregi("(.*):([1-9]+): syntax error", $value, $results)) {
				$file = GetPathLastComponent($results[1]);
				print("---ERROR_START---\n");
				print("Syntax error|$results[2]|$file|\n");
				print("---ERROR_END---\n");
			}
			
			// parse the error and return formatted results
			if (eregi("(.*):([1-9]+):in `(.*)': (.*) \((.*)\)", $value, $results)) {
				$file = GetPathLastComponent($results[1]);
				$output = "$results[5]: $results[4]|$results[2]|$file|";
			}
		}
	}
	
	pclose($handle);
	
	// print to STDOUT for web-scripter!
	if ($output or $stack_frames) {
		print("---ERROR_START---\n");
		print("$output\n");
		print("$stack_frames\n");
		print("---ERROR_END---\n");
	} else {
		// print the entire buffer
		print($buffer);
	}
	
	//print_r($GLOBALS);
?>