
<?php
	include("common.php");
	
	$input = ArgvToInput();
	$root = GetDocumentRoot();
	
 	$tidy = "/$root/tidy";
 	$error_log = "ws_tidy_errors.txt";
	$options = "-e -q -f $error_log"; //$input['options']
	$file = $input['file'];
	
	// launch tidy
	$handle = popen("$tidy $options \"$file\"", "r");
	//$buffer = fread($handle, 1024 * 32);
	//print($buffer);
	pclose($handle);
	
	// read the error log
	if ($handle = @fopen($error_log, "r")) {
	
		$content = "";
		while (!feof($handle)) {
			$buffer = fread($handle, 1024);
			$content .= "$buffer";
		}
		fclose($handle);
		
		// format and print to STDOUT
		/*
			message|line|column|file
		*/
		if ($content != "") {
			$lines = explode("\n", $content);
			foreach ($lines as $value) {
				
				// parse the error
				if (eregi("^line ([1-9]+) column ([1-9]+) - (.*):(.*)", $value, $results)) {
					print("$results[3]: $results[4]|$results[1]|$results[2]|self|\n");
				}
				// line 12 column 1 - Warning: missing <!DOCTYPE> declaration
			}
		} else {
			print("No warnings or errors were found.");
		}
		
		// delete the error log
		unlink($error_log);
 	}
	
	//print_r($GLOBALS);
?>